import 'dart:async';
import 'package:cloud_firestore/cloud_firestore.dart';

class FirestoreService<T> {
  final Query query;

  FirestoreService(this.query) {
    query.snapshots().listen((event) {
      final List<Map<String, dynamic>> data = [for (final doc in event.docs) doc.data() as Map<String, dynamic>];

      _streamController.add(data);
    });
  }

  final StreamController<List<Map<String, dynamic>>> _streamController = StreamController<List<Map<String, dynamic>>>();

  Stream<List<T>> getStream(Function(Map<String, dynamic>) object) async* {
    await for (final List<Map<String, dynamic>> jsons in _streamController.stream) {
      yield [for (final json in jsons) object(json)];
    }
  }
}