import 'package:flutter/material.dart';
import 'view_util.dart';

Future showSignInDialogView(BuildContext context, Widget screen) async {
  await showDialogView(
      context,
      builder: (context) => AlertDialog(
        title: Text("Sign in required"),
        content: Column(
          mainAxisSize: MainAxisSize.min,
          crossAxisAlignment: CrossAxisAlignment.start,
          children: [
            Text('Please sign in or create a free account to continue.'),
          ],
        ),
        actions: [
          TextButton(
            onPressed: () {
              Navigator.pop(context);
            },
            child: Text("CANCEL"),
          ),
          TextButton(
            onPressed: () async {
              Navigator.pop(context);

              await pushView(context, screen);
            },
            child: Text("SIGN IN"),
          )
        ],
      )
  );
}