import 'package:chewie/chewie.dart';
import 'package:flutter/material.dart';
import 'package:flutter_helper/flutter_helper.dart';
import 'package:video_player/video_player.dart';

class UrlVideoPlayerView extends StatefulWidget {
  final String url;

  const UrlVideoPlayerView({
    required this.url
  });

  @override
  _UrlVideoPlayerViewState createState() => _UrlVideoPlayerViewState();
}

class _UrlVideoPlayerViewState extends State<UrlVideoPlayerView> {
  late VideoPlayerController _videoPlayerController;
  late ChewieController _chewieController;

  @override
  void didUpdateWidget(covariant UrlVideoPlayerView oldWidget) {
    // TODO: implement didUpdateWidget
    super.didUpdateWidget(oldWidget);

    _videoPlayerController = VideoPlayerController.network(widget.url);

    _chewieController = ChewieController(
      videoPlayerController: _videoPlayerController,
      aspectRatio: _videoPlayerController.value.aspectRatio,
    );
  }

  late Future<void> _future;

  @override
  void initState() {
    super.initState();

    _future = () async {
      _videoPlayerController = VideoPlayerController.network(widget.url);

      await _videoPlayerController.initialize();

      _chewieController = ChewieController(
        videoPlayerController: _videoPlayerController,
        aspectRatio: _videoPlayerController.value.aspectRatio,
      );
    }();
  }

  @override
  void dispose() {
    // TODO: implement dispose
    super.dispose();

    _videoPlayerController.dispose();

    _chewieController.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return FutureView<void>(
      future: _future,
      builder: (context, snapshot) {
        return AspectRatio(
            aspectRatio: _chewieController.aspectRatio!,
            child: Chewie(controller: _chewieController));
      }
    );
  }
}